ROUTE(8)

NAME
route - manually manipulate the routing tables

SYNOPSIS
route [-dnqtv] [-T tableid] command [ [modifiers] args]

DESCRIPTION
route is a utility used to manually view and manipulate the network routing tables. Except for setting up the default route, it normally is not needed to manipulate routes, as a system routing table management daemon, such as ripd(8), ospfd(8), or bgpd(8), should tend to this task.

route can be used to modify nearly any aspect of the routing policy, except packet forwarding, which can be manipulated through the sysctl(8) command.

The route utility supports a limited number of general options, but a rich command language enables the user to specify any arbitrary request that could be delivered via the programmatic interface discussed in route(4).

The options are as follows:

-d  Run in debug-only mode, i.e., don't actually modify the routing table.

-n  Bypass attempts to print host and network names symbolically when reporting actions. (The process of translating between symbolic names and numerical equivalents can be quite time consuming, and may require correct operation of the network; thus it may be expedient to forgo this, especially when attempting to repair networking operations.)

-q  Suppress all output.

-T tableid
    Select an alternate routing table to modify or query. The default is to use the current routing table.

-t  Write routing messages to a fake device (/dev/null) instead of a real routing socket to test route manipulation.

-v  (verbose) Print additional details.

The route utility provides the following simple commands:

    route [-T tableid] exec [command ...] Execute a command forcing the process and its children to use the routing table and appropriate routing domain as specified with the -T tableid option.

    route [-nqv] [-T tableid] flush [modifiers] Delete all gateway entries from the routing table. When the address family is specified by any one of the family modifiers (listed below), only routes having destinations with addresses in the delineated family will be deleted. Also, only routes matching a specific interface or priority can be flushed by using the -iface or -priority modifiers.

    route [-nv] [-T tableid] get [modifiers] address Extract a routing entry from the kernel. If -gateway is specified, only routes whose gateway are in the same address family as the destination are shown.

    route [-n] monitor [modifiers] Continuously report any changes to the routing information base, routing lookup misses, or suspected network partitionings.

    When the address family is specified by any one of the family modifiers (listed below), only routes having destinations with addresses in the delineated family will be shown. If the -iface modifier is used only interface specific messages (link state changes) are shown.

    route [-nv] [-T tableid] show [family] [-gateway] [-label label] Print out the route table similar to "netstat -r" (see netstat(1)).

    If -gateway is specified, only routes whose gateway are in the same address family as the destination are shown.

    If -label is specified, only routes with the specified label are shown.

The other commands relating to adding, changing, or deleting routes have the syntax:

    route [-dnqtv] [-T tableid] add [modifiers] destination gateway
    route [-dnqtv] [-T tableid] change [modifiers] destination gateway
    route [-dnqtv] [-T tableid] delete [modifiers] destination gateway

destination is the destination host or network; gateway is the next-hop intermediary via which packets should be routed. Routes to a particular host may be distinguished from those to a network by interpreting the Internet address specified as the destination argument. The optional modifiers -net and -host cause the destination to be interpreted as a network or a host, respectively. Otherwise, type is chosen based on the following rules:

The route is assumed to be to a network if any of the following apply to destination:

•   it is the word "default", equivalent to 0/0
•   it is an IPv4 address with less than 3 dots
•   it is an IPv4 address with a “/XX” suffix (where XX is the number of bits in the network portion of the address and is less than 32)
•   it is an IPv6 address with a “/XX” suffix (where XX is the number of bits in the network portion of the address and is less than 128)
•   it is the symbolic name of a network.

If destination is a valid IP address or host name, it is presumed to be a route to a host.

For example, 192.168.1.1 is interpreted as -host 192.168.1.1 and 192.168.1 is interpreted as -net 192.168.1. Note, however, that 192.168.2.0 will be interpreted as -host 192.168.2.0 since it is a complete IP address with 3 dots. In this case the number of bits in the network portion of the address must be explicitly listed, for example 192.168.2.0/24, 192.168.2/24, or alternately 192.168.2.

If the destination is directly reachable via an interface requiring no intermediary system to act as a gateway, the -iface modifier should be specified; the gateway given is the address of this host on the common network, indicating the interface to be used for transmission.

To allow addresses to be interpreted as belonging to a particular address family (as well as for use in the family arguments to some commands), the following modifiers may be used:

-inet
    Internet Protocol version 4 (IPv4) addresses (see ip(4))
-inet6
    Internet Protocol version 6 (IPv6) addresses (see ip6(4))
-link
    Hardware (link-level) addresses
-mpls
    MPLS addresses
-sa Actual sockaddr data, in hexadecimal format

In the absence of modifiers, an address is assumed to be IPv4, unless containing a ‘’: character, when it is treated as IPv6.

The optional modifier -link specifies that all subsequent addresses are specified as link-level addresses, and the names must be numeric specifications rather than symbolic names.

The optional -netmask qualifier is intended to manually add subnet routes with netmasks different from that of the implied network interface (as would otherwise be communicated using a routing protocol). One specifies an additional ensuing address parameter (to be interpreted as a network mask). The implicit network mask generated in the AF_INET case can be overridden by making sure this option follows the destination parameter. -prefixlen is also available for a similar purpose, for IPv6/v4.

A specific routing priority can be specified with the optional -priority qualifier. If no priority is specified the kernel will set a priority depending on the RTF_STATIC flag to either RTP_STATIC or RTP_DEFAULT.

The optional -mpath modifier needs to be specified with the add command to be able to enter multiple gateways for the same destination address (multipath). When multiple routes exist for a destination, one route is selected based on the source address of the packet. The sysctl(8) variables net.inet.ip.multipath and net.inet6.ip6.multipath are used to control multipath routing. If set to 1, multiple routes with the same priority are used equally; if set to 0, the first route selected will be used for subsequent packets to that destination regardless of source.

When inserting MPLS routes, particular modifiers must be used. The -mplslabel modifier needs to be specified in an ingress LSR to associate a particular label to an IPv4/IPv6 route. The MPLS traffic -in and -out modifiers are intended to identify the ingress label and, optionally, the outgoing one. Additionally, one of the following operations must be used: -push, -pop and -swap. Route's nexthop can be specified with the modifier -inet.

Routes have associated flags which influence operation of the protocols when sending to destinations matched by the routes. These flags may be set (or sometimes cleared) by indicating the following corresponding modifiers:
-blackhole | RTF_BLACKHOLE | silently discard pkts (during updates)
-cloning | RTF_CLONING | generates a new route on use
-iface | ~RTF_GATEWAY | destination is directly reachable
-llinfo | RTF_LLINFO | validly translates proto addr to link addr
-mpath | RTF_MPATH | multiple gateways for a destination exist
-nostatic | ~RTF_STATIC | pretend route added by kernel or daemon
-proto1 | RTF_PROTO1 | set protocol specific routing flag #1
-proto2 | RTF_PROTO2 | set protocol specific routing flag #2
-reject | RTF_REJECT | emit an ICMP unreachable when matched
-static | RTF_STATIC | manually added route
-xresolve | RTF_XRESOLVE | emit mesg on use (for external lookup)

The optional modifiers -expire and -mtu provide initial values to quantities maintained in the routing entry by transport level protocols, such as TCP (see tcp(4)). They have the following meanings:

-expire n
    Lifetime for route (e.g., if generated by a redirect).
-mtu n
    Maximum transmission unit (MTU) size for this path.

These may be individually locked by preceding each such modifier to be locked by the -lock meta-modifier, or one can specify that all ensuing metrics may be locked by the -lockrest meta-modifier.

In a change or add command where the destination and gateway are not sufficient to specify the route, the -ifp or -ifa modifiers may be used to determine the interface name or interface address.

The optional -label modifier specifies on route addition or modification that the route should have the given label associated with it. Route labels can be used to attach arbitrary information to a route.

All symbolic names specified for a destination or gateway are looked up first as a network name using getnetbyname(3). If this lookup fails, gethostbyname(3) is then used to interpret the name as a valid host name.

route uses a routing socket (see route(4)) and the message types RTM_ADD, RTM_DELETE, RTM_GET, and RTM_CHANGE. As such, only the superuser may modify the routing tables.

FILES
/etc/hosts
    host name database
/etc/mygate
    default gateway address
/etc/networks
    network name database

EXAMPLES
Add a static inet(4) route to the 192.168.5.0/24 network via the 192.168.0.1 gateway:

    # route add -inet 192.168.5.0/24 192.168.0.1

Amend the inet(4) route to the 192.168.5.0/24 network to use the 192.168.0.2 gateway:

    # route change -inet 192.168.5.0/24 192.168.0.2

Delete the inet(4) route to the 192.168.5.0/24 network:

    # route delete -inet 192.168.5.0/24

DIAGNOSTICS

%s: gateway %s flags %x The specified route is being added to or deleted from the tables. The values printed are from the routing table entry supplied in the ioctl(2) call. If the gateway address used was not the primary address of the gateway (the first one returned by gethostbyname(3)), the gateway address is printed numerically as well as symbolically.

%s %s done When the flush command is specified, each routing table entry deleted is indicated with a message of this form.

Network is unreachable An attempt to add a route failed because the gateway listed was not on a directly connected network. The next-hop gateway must be given.

not in table A delete operation was attempted for an entry which wasn't present in the tables.

routing table overflow An add operation was attempted, but the system was low on resources and was unable to allocate memory to create the new entry.

SEE ALSO
netstat(1), gethostbyname(3), getnetbyname(3), netintro(4), route(4), tcp(4), hosts(5), mygate(5), networks(5), bgpd(8), ospfd(8), ripd(8), sysctl(8)

HISTORY
The route command appeared in 4.2BSD. IPv6 support was added by WIDE/KAME project.

The -recvpipe, -hopcount, -sendpipe, -ssthres, -rtt, and -rttvar modifiers used to be used to initialize various quantities in routing table entries. The routing system no longer uses these values and the modifiers exist now only for compatibility with other operating systems.

BUGS
Some uses of the -ifa or -ifp modifiers with the add command will incorrectly fail with a “Network is unreachable” message if there is no default route. See case RTM_ADD in route_output() from sys/net/rtsock.c for details.